Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkVoxelContoursToSurfaceFilter Class Reference

`#include <vtkVoxelContoursToSurfaceFilter.h>`

Inheritance diagram for vtkVoxelContoursToSurfaceFilter:

[legend]
Collaboration diagram for vtkVoxelContoursToSurfaceFilter:

[legend]
List of all members.

## Detailed Description

create surface from contours

Date:
  2002/01/22 15:29:55

Revision:
  1.18

vtkVoxelContoursToSurfaceFilter is a filter that takes contours and produces surfaces. There are some restrictions for the contours:

- The contours are input as vtkPolyData, with the contours being polys in the vtkPolyData.
- The contours lie on XY planes - each contour has a constant Z
- The contours are ordered in the polys of the vtkPolyData such that all contours on the first (lowest) XY plane are first, then continuing in order of increasing Z value.
- The X, Y and Z coordinates are all integer values.
- The desired sampling of the contour data is 1x1x1 - Aspect can be used to control the aspect ratio in the output polygonal dataset.

This filter takes the contours and produces a structured points dataset of signed floating point number indicating distance from a contour. A contouring filter is then applied to generate 3D surfaces from a stack of 2D contour distance slices. This is done in a streaming fashion so as not to use to much memory.

See also:
  vtkPolyDataToPolyDataFilter

Created by:
  - Avila, Lisa

CVS contributions (if > 5%):
  - Avila, Lisa (94%)

CVS logs (CVSweb):
  - .`h` (`/Graphics/vtkVoxelContoursToSurfaceFilter.h)`
  - .`cxx` (`/Graphics/vtkVoxelContoursToSurfaceFilter.cxx)`

Tests:
  vtkVoxelContoursToSurfaceFilter (Tests)

Definition at line 64 of file vtkVoxelContoursToSurfaceFilter.h.

## Public Types
typedef vtkPolyDataToPolyDataFilter | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual void | SetSpacing (float, float, float)
virtual void | SetSpacing (float[3])
virtual float * | GetSpacing ()
virtual void | GetSpacing (float data[3])
virtual void | SetMemoryLimitInBytes (int)
virtual int | GetMemoryLimitInBytes ()
## Static Public Methods
vtkVoxelContoursToSurfaceFilter * | New ()
int | IsTypeOf (const char *type)
vtkVoxelContoursToSurfaceFilter * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkVoxelContoursToSurfaceFilter ()
| ~vtkVoxelContoursToSurfaceFilter ()
void | Execute ()
void | AddLineToLineList (float x1, float y1, float x2, float y2)
void | SortLineList ()
void | CastLines (float *slice, float gridOrigin[3], int gridSize[3], int type)
void | PushDistances (float *ptr, int gridSize[3], int chunkSize)
## Protected Attributes
int | MemoryLimitInBytes
float | Spacing [3]
float * | LineList
int | LineListLength
int | LineListSize
float * | SortedXList
float * | SortedYList
int | SortedListSize
int * | WorkingList
int | WorkingListLength
float * | IntersectionList
int | IntersectionListLength

## Member Typedef Documentation

typedef vtkPolyDataToPolyDataFilter vtkVoxelContoursToSurfaceFilter::Superclass

| Reimplemented from vtkPolyDataToPolyDataFilter. Definition at line 68 of file vtkVoxelContoursToSurfaceFilter.h.

## Constructor & Destructor Documentation

vtkVoxelContoursToSurfaceFilter::vtkVoxelContoursToSurfaceFilter | ( |  | ) | `[protected]`

vtkVoxelContoursToSurfaceFilter::~vtkVoxelContoursToSurfaceFilter | ( |  | ) | `[protected]`

## Member Function Documentation

vtkVoxelContoursToSurfaceFilter* vtkVoxelContoursToSurfaceFilter::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkVoxelContoursToSurfaceFilter::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkPolyDataToPolyDataFilter.

int vtkVoxelContoursToSurfaceFilter::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataToPolyDataFilter.

virtual int vtkVoxelContoursToSurfaceFilter::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataToPolyDataFilter.

vtkVoxelContoursToSurfaceFilter* vtkVoxelContoursToSurfaceFilter::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkPolyDataToPolyDataFilter.

void vtkVoxelContoursToSurfaceFilter::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkPolyDataToPolyDataFilter.

virtual void vtkVoxelContoursToSurfaceFilter::SetMemoryLimitInBytes | ( | int |  | ) | `[virtual]`

| Set / Get the memory limit in bytes for this filter. This is the limit of the size of the structured points data set that is created for intermediate processing. The data will be streamed through this volume in as many pieces as necessary.

virtual int vtkVoxelContoursToSurfaceFilter::GetMemoryLimitInBytes | ( |  | ) | `[virtual]`

| Set / Get the memory limit in bytes for this filter. This is the limit of the size of the structured points data set that is created for intermediate processing. The data will be streamed through this volume in as many pieces as necessary.

virtual void vtkVoxelContoursToSurfaceFilter::SetSpacing | ( | float | ,
|  | float | ,
|  | float |
| ) | `[virtual]`

virtual void vtkVoxelContoursToSurfaceFilter::SetSpacing | ( | float | [3] | ) | `[virtual]`

virtual float* vtkVoxelContoursToSurfaceFilter::GetSpacing | ( |  | ) | `[virtual]`

virtual void vtkVoxelContoursToSurfaceFilter::GetSpacing | ( | float | data[3] | ) | `[virtual]`

void vtkVoxelContoursToSurfaceFilter::Execute | ( |  | ) | `[protected, virtual]`

| This method is the old style execute method Reimplemented from vtkSource.

void vtkVoxelContoursToSurfaceFilter::AddLineToLineList | ( | float | x1,
|  | float | y1,
|  | float | x2,
|  | float | y2
| ) | `[protected]`

void vtkVoxelContoursToSurfaceFilter::SortLineList | ( |  | ) | `[protected]`

void vtkVoxelContoursToSurfaceFilter::CastLines | ( | float * | slice,
|  | float | gridOrigin[3],
|  | int | gridSize[3],
|  | int | type
| ) | `[protected]`

void vtkVoxelContoursToSurfaceFilter::PushDistances | ( | float * | ptr,
|  | int | gridSize[3],
|  | int | chunkSize
| ) | `[protected]`

## Member Data Documentation

int vtkVoxelContoursToSurfaceFilter::MemoryLimitInBytes`[protected]`

| Definition at line 89 of file vtkVoxelContoursToSurfaceFilter.h.

float vtkVoxelContoursToSurfaceFilter::Spacing[3]`[protected]`

| Definition at line 91 of file vtkVoxelContoursToSurfaceFilter.h.

float* vtkVoxelContoursToSurfaceFilter::LineList`[protected]`

| Definition at line 93 of file vtkVoxelContoursToSurfaceFilter.h.

int vtkVoxelContoursToSurfaceFilter::LineListLength`[protected]`

| Definition at line 94 of file vtkVoxelContoursToSurfaceFilter.h.

int vtkVoxelContoursToSurfaceFilter::LineListSize`[protected]`

| Definition at line 95 of file vtkVoxelContoursToSurfaceFilter.h.

float* vtkVoxelContoursToSurfaceFilter::SortedXList`[protected]`

| Definition at line 97 of file vtkVoxelContoursToSurfaceFilter.h.

float* vtkVoxelContoursToSurfaceFilter::SortedYList`[protected]`

| Definition at line 98 of file vtkVoxelContoursToSurfaceFilter.h.

int vtkVoxelContoursToSurfaceFilter::SortedListSize`[protected]`

| Definition at line 99 of file vtkVoxelContoursToSurfaceFilter.h.

int* vtkVoxelContoursToSurfaceFilter::WorkingList`[protected]`

| Definition at line 101 of file vtkVoxelContoursToSurfaceFilter.h.

int vtkVoxelContoursToSurfaceFilter::WorkingListLength`[protected]`

| Definition at line 102 of file vtkVoxelContoursToSurfaceFilter.h.

float* vtkVoxelContoursToSurfaceFilter::IntersectionList`[protected]`

| Definition at line 104 of file vtkVoxelContoursToSurfaceFilter.h.

int vtkVoxelContoursToSurfaceFilter::IntersectionListLength`[protected]`

| Definition at line 105 of file vtkVoxelContoursToSurfaceFilter.h.

The documentation for this class was generated from the following file:

- Graphics/vtkVoxelContoursToSurfaceFilter.h